"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const Qs = __importStar(require("querystring"));
const fs = __importStar(require("fs"));
const moment_1 = __importDefault(require("moment"));
function AuthUrl(client_id, scope) {
    const open = [
        "https://login.microsoftonline.com/common/oauth2/v2.0/authorize?",
        `client_id=${client_id}&`,
        `scope=${encodeURIComponent(scope)}&`,
        "response_type=code&",
        `redirect_uri=${encodeURIComponent(redirect_uri)}`,
    ].join('');
    console.log('open', open);
    return open;
}
exports.AuthUrl = AuthUrl;
const INFO_PATH = process.env['HOME'] + '/.odInfo.json';
const redirect_uri = 'http://localhost:44321';
function exToken(code, client_id, client_secret) {
    return __awaiter(this, void 0, void 0, function* () {
        const params = {
            code, client_secret, client_id, redirect_uri,
            grant_type: 'authorization_code',
        };
        const resp = yield axios_1.default.post('https://login.microsoftonline.com/common/oauth2/v2.0/token', Qs.stringify(params));
        resp.data.client_id = client_id;
        resp.data.client_secret = client_secret;
        resp.data.expires_at = resp.data.expires_in + moment_1.default().unix();
        console.log(resp.data, INFO_PATH);
        fs.writeFile(INFO_PATH, JSON.stringify(resp.data), err => err);
        return resp.data;
    });
}
exports.exToken = exToken;
function getToken() {
    return __awaiter(this, void 0, void 0, function* () {
        const bf = fs.readFileSync(INFO_PATH);
        const info = JSON.parse(bf.toString());
        if (info.expires_at > moment_1.default().unix()) {
            return info;
        }
        const params = {
            client_id: info.client_id,
            client_secret: info.client_secret,
            grant_type: 'refresh_token',
            redirect_uri: redirect_uri,
            refresh_token: info.refresh_token,
        };
        const resp = yield axios_1.default.post('https://login.microsoftonline.com/common/oauth2/v2.0/token', Qs.stringify(params));
        resp.data.expires_at = resp.data.expires_in + moment_1.default().unix();
        Object.assign(info, resp.data);
        fs.writeFile(INFO_PATH, JSON.stringify(info), err => err);
        return info;
    });
}
exports.getToken = getToken;
function fsStat(path) {
    return new Promise((res, rej) => {
        fs.access(path, (err) => {
            if (err) {
                return res();
            }
            fs.stat(path, (err, st) => {
                err ? rej(err) : res(st);
            });
        });
    });
}
exports.fsStat = fsStat;
